Name:           ppc64-diag
Version:        2.7.0
Release:        1%{?dist}
Summary:        Linux for Power Platform Diagnostics
URL:            http://sourceforge.net/projects/linux-diag/files/ppc64-diag/
Group:          System Environment/Base
License:        GPLv2
ExclusiveArch:  ppc ppc64
BuildRequires:  libservicelog-devel, flex, perl, byacc, librtas-devel >= 1.4.0
BuildRequires:  libvpd-devel, ncurses-devel, libudev-devel
Requires:       servicelog, lsvpd >= 1.7.1
# PCI hotplug support on PowerKVM guest depends on below
# powerpc-utils version.
Requires:   powerpc-utils >= 1.3.0

Requires (preun): /sbin/chkconfig
Requires (preun): /sbin/service
Requires (post): /sbin/chkconfig
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Source0: http://downloads.sourceforge.net/linux-diag/%{name}/%{name}-%{version}.tar.gz
Patch0:         ppc64-diag-2.4.2-messagecatalog-location.patch
# Fixes recompilation on install
Patch1:         ppc64-diag-2.6.6-makefile-install-fix.patch
Patch2:         ppc64-diag-2.4.2-init-location.patch
# Fixes SELinux context
Patch3:         ppc64-diag-2.6.7-restorecon.patch
# patch from https://bugzilla.novell.com/show_bug.cgi?id=882667
# attachment https://bugzilla.novell.com/attachment.cgi?id=599147
# resolving https://bugzilla.redhat.com/show_bug.cgi?id=1201295
Patch4:         ppc64-diag-tmpraces.patch
#add servagent script to the package(no longer installed by default by upstream)
Patch9:         ppc64-diag-2.4.3-servagent.patch

%description
Platform diagnostics for Linux for Power writes events reported by the
System p or System i platform firmware to the service log, provides automated
responses to urgent events such as environmental conditions and predictive
failures, and provides notifications of the event to system administrators
or connected service frameworks.  Some error log analysis parameters can be
configured in /etc/ppc64-diag/ppc64-diag.config.

%prep
%setup -q
%patch0 -p1 -b .msg_loc
%patch1 -p1 -b .make
%patch2 -p1 -b .init-location
%patch3 -p1 -b .con
%patch4 -p1 -b .tmp
%patch9 -p1 -b .servagent

%build
make %{?_smp_mflags} CFLAGS+="$RPM_OPT_FLAGS -DDEBUG -fPIE -pipe -Wextra -fno-strict-aliasing -I \$(COMMON_DIR)\/"

%install
make install DESTDIR=$RPM_BUILD_ROOT
chmod 644 COPYING
rm -f $RPM_BUILD_ROOT/usr/share/doc/packages/ppc64-diag/COPYING
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/%{name}
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/%{name}/ses_pages
mkdir -p $RPM_BUILD_ROOT/%{_var}/log/dump

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr (-,root,root,-)
%doc COPYING
%dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/ses_pages
%dir %{_var}/log/dump
%{_mandir}/man8/*
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/%{name}/ppc64-diag.config
%attr(755,root,root) %{_sbindir}/*
%dir %{_datadir}/%{name}
%dir %attr(755,root,root) %{_datadir}/%{name}/message_catalog/
%attr(755,root,root) %{_sysconfdir}/%{name}/lp_diag_notify
%attr(755,root,root) %{_sysconfdir}/%{name}/lp_diag_setup
%attr(755,root,root) %{_sysconfdir}/%{name}/ppc64_diag_migrate
%attr(755,root,root) %{_sysconfdir}/%{name}/ppc64_diag_mkrsrc
%attr(755,root,root) %{_sysconfdir}/%{name}/ppc64_diag_notify
%attr(755,root,root) %{_sysconfdir}/%{name}/ppc64_diag_servagent
%attr(755,root,root) %{_sysconfdir}/%{name}/ppc64_diag_setup
%attr(755,root,root) %{_sysconfdir}/%{name}/prrn_hotplug
%attr(644,root,root) %{_sysconfdir}/%{name}/servevent_parse.pl
%attr(644,root,root) %{_datadir}/%{name}/message_catalog/cxgb3
%attr(644,root,root) %{_datadir}/%{name}/message_catalog/e1000e
%attr(644,root,root) %{_datadir}/%{name}/message_catalog/exceptions
%attr(644,root,root) %{_datadir}/%{name}/message_catalog/gpfs
%attr(644,root,root) %{_datadir}/%{name}/message_catalog/reporters
%attr(644,root,root) %{_datadir}/%{name}/message_catalog/with_regex/*
%attr(755,root,root) %{_sysconfdir}/rc.powerfail
%attr(755,root,root) %{_sysconfdir}/rc.d/init.d/rtas_errd
%attr(755,root,root) %{_sysconfdir}/rc.d/init.d/opal_errd

%post
# Post-install script --------------------------------------------------
%{_sysconfdir}/%{name}/ppc64_diag_setup --register >/dev/null
%{_sysconfdir}/%{name}/lp_diag_setup --register >/dev/null
/sbin/chkconfig --add rtas_errd
/sbin/chkconfig --add opal_errd

if [ "$1" = "2" ]; then # upgrade
    %{_sysconfdir}/rc.d/init.d/rtas_errd restart || %{_sysconfdir}/rc.d/init.d/opal_errd restart
fi

%preun
# Pre-uninstall script -------------------------------------------------
if [ "$1" = "0" ]; then # last uninstall
    %{_sysconfdir}/rc.d/init.d/opal_errd stop >/dev/null 2>&1 || %{_sysconfdir}/rc.d/init.d/rtas_errd stop >/dev/null 2>&1
    /sbin/chkconfig --del rtas_errd
    /sbin/chkconfig --del opal_errd
    %{_sysconfdir}/%{name}/ppc64_diag_setup --unregister >/dev/null
    %{_sysconfdir}/%{name}/lp_diag_setup --unregister >/dev/null
fi

%triggerin -- librtas
# trigger on librtas upgrades ------------------------------------------
if [ "$2" = "2" ]; then
    %{_sysconfdir}/rc.d/init.d/opal_errd restart || %{_sysconfdir}/rc.d/init.d/rtas_errd restart
fi


%changelog
* Tue Feb 09 2016 Rafael Fonseca <rdossant@redhat.com> - 2.7.0-1
- Related: #1252717 - update to 2.7.0
- Resolves: #1305898 - change to GPL license

* Thu Dec 10 2015 Rafael Fonseca <rdossant@redhat.com> - 2.6.10-1
- Resolves: #1252717 - rebase to 2.6.10

* Thu May 28 2015 Jakub Čajka <jcajka@redhat.com> 2.6.7-4
- Resolves: #1224739 LPM: Serial number not updated after LPAR migration (ppc64-diag)

* Mon Mar 16 2015 Jakub Čajka <jcajka@redhat.com> 2.6.7-3
- Resolves: #1201295 - CVE-2014-4039 CVE-2014-4038 ppc64-diag: multiple temporary file races [rhel-6.7]

* Wed Feb 18 2015 Jakub Čajka <jcajka@redhat.com> 2.6.7-2
- Related: #1148142 - added missing directory

* Mon Feb 16 2015 Jakub Čajka <jcajka@redhat.com> 2.6.7-1
- Resolves: #1131501 - Mislabeled file '/var/lock/subsys/rtas_errd' found
- Resolves: #1139655 - explain_syslog and syslog_to_svclog commands are failing with "/etc/ppc64-diag/message_catalog/reporters: No such file or directory" (ppc64-diag)
- Resolves: #1148142 - [6.7 FEAT] ppc64-diag package update - ppc64

* Mon May 05 2014 Jakub Čajka <jcajka@redhat.com> 2.6.6-2 
- Related: #929278 - Fixed Makefile to respect build flags

* Tue Apr 22 2014 Jakub Čajka <jcajka@redhat.com> 2.6.6-1
- Update to 2.6.6
- Resolves: #929278 - [6.6 FEAT] ppc64-diag package update - ppc64
- Resolves: #949612 - [6.6 FEAT] LightPath Diagnostics framework on PowerLinux (ppc64-diag)
- Resolves: #1021520 - [6.6 FEAT] Dynamic CPU Affinity via the PRRN interface from user space (ppc64-diag) (POWER7+)
- Resolves: #1021518 - [6.6 FEAT] Dynamic Memory Affinity via the PRRN interface from user space (ppc64-diag) (POWER7+) 

* Fri Aug 02 2013 Filip Kocina <fkocina@redhat.com> 2.6.1-2
- Resolves: #988237 - clears file conflicts

* Wed Jul 17 2013 Filip Kocina <fkocina@redhat.com> 2.6.1-1
- Resolves: #929278 - rebase to 2.6.1

* Wed Nov 21 2012 Filip Kocina <fkocina@redhat.com> 2.5.0-2
- Resolves: #878314 - creates new default ses_pages directory

* Tue Oct 02 2012 Filip Kocina <fkocina@redhat.com> 2.5.0-1
- Resolves:#822653 - rebase to 2.5.0

* Thu Sep 27 2012 Ondrej Vasik <ovasik@redhat.com> 2.4.3-1
- Resolves:#822653 - rebase to 2.4.3
- Resolves:#833619 - CPU could not be guarded off
  in response to a received predictive CPU failure

* Fri May 04 2012 Lukas Nykryn <lnykryn@redhat.com> 2.4.2-10
- Resolves: #818441 - rtas_errd does not automatically start

* Thu Apr 19 2012 Lukas Nykryn <lnykryn@redhat.com> 2.4.2-9
- Resolves: #814170 - ppc64-diag: "Kernel ID: " field is always "0"

* Tue Apr 17 2012 Lukas Nykryn <lnykryn@redhat.com> 2.4.2-8
- Resolves: #805048 - Discard output of rtas_errd stop
- Resolves: #812103 - Compile with -DDEBUG option

* Wed Feb 15 2012 Jiri Skala <jskala@redhat.com> 2.4.2-7
- Resolves: #632735 - New PAckage: ppc64-diag - added no-strict-aliasing

* Wed Feb 15 2012 Jiri Skala <jskala@redhat.com> 2.4.2-6
- Resolves: #632735 - New PAckage: ppc64-diag - adds correct cflags

* Mon Feb 13 2012 Jiri Skala <jskala@redhat.com> 2.4.2-5
- Resolves: #632735 - New Package: ppc64-diag-2.3.4+ - initial RHEL version, based on IBM spec file

* Thu Sep 22 2011 Karsten Hopp <karsten@redhat.com> 2.4.2-4
- fix preun and post install scriptlets

* Fri Sep 09 2011 Karsten Hopp <karsten@redhat.com> 2.4.2-3
- add buildrequirement systemd-units for _unitdir rpm macro
- move helper scripts to libexecdir/ppc64-diag

* Wed Sep 07 2011 Karsten Hopp <karsten@redhat.com> 2.4.2-2       
- additional fixes for Fedora package review (bugzilla #736062)

* Wed Aug 17 2011 Karsten Hopp <karsten@redhat.com> 2.4.2-1
- initial Fedora version, based on IBM spec file with rpmlint cleanups
  - move scripts to /usr/share/ppc-diag
  - don't start service automatically after install
